import graphsurgeon as gs
import tensorflow as tf

# skip = gs.create_node("skip", op="skip", dtype=tf.float32)

# conv_cls1 = gs.create_node("conv_cls1", op="reshape_to_4", dtype=tf.float32)
# conv_cls2 = gs.create_node("conv_cls2", op="reshape_to_4", dtype=tf.float32)

output = gs.create_node("output", op="flatten", dtype=tf.float32,
                        inputs=['Conv_1/Relu', 'Conv_2/Relu'])
# dummy0 = gs.create_node("dummy0", op="anchor", dtype=tf.float32, shape=(11520, 4, 1) )
# dummy1 = gs.create_node("dummy1", op="Printer", dtype=tf.float32)


namespace_plugin_map = {
    "output": output,
    # "custom0": dummy0,
    # "custom1": dummy1,
    # "branch_1/custom_1": dummy1,
    # "Reshape": conv_cls1,
    # "branch_0/Reshape": conv_cls1,
    # "branch_1/Reshape": conv_cls2,
}




def preprocess(dynamic_graph):
    # Now create a new graph by collapsing namespaces
    dynamic_graph.collapse_namespaces(namespace_plugin_map)
    # Remove the outputs, so we just have a single output node (NMS).
    # dynamic_graph.remove(dynamic_graph.graph_outputs, remove_exclusive_dependencies=False)

    def display_nodes(nodes):
        for i, node in enumerate(nodes):
            print('%d %s %s' % (i, node.name, node.op))
            [print(u'└─── %d ─ %s' % (i, n)) for i, n in enumerate(node.input)]

    def find_nodes(name):
        return [node for node in dynamic_graph._internal_graphdef.node if node.name == name]

    # node = dynamic_graph.find_nodes_by_name('skip')
    # dynamic_graph.forward_inputs(node)

    # node = dynamic_graph.find_nodes_by_name('conv_cls1')
    # dynamic_graph.forward_inputs(node)
    # node = dynamic_graph.find_nodes_by_name('conv_cls2')
    # dynamic_graph.forward_inputs(node)

    display_nodes(dynamic_graph.as_graph_def().node)
